/* $Header: /home/yav/catty/lupe/RCS/timer.c,v 1.2 1995/06/01 16:54:22 yav Exp $
 * Time control routine
 * written by yav (UHD98984@pcvan.or.jp)
 */

#include <X11/Xos.h>
#include <stdio.h>
#include "config.h"

#ifdef _BSD_SOURCE
#define USE_GETTIMEOFDAY	/* use gettimeofday system call */
#define USE_USLEEP		/* use usleep library */
#endif

#ifdef USE_GETTIMEOFDAY
#define TMV timeval
#else
struct TMV {
  long tv_sec;			/* seconds */
  long tv_usec;			/* microseconds */
};
#endif

static struct TMV tm0;

void current_time(p)
     struct TMV *p;
{
#ifdef USE_GETTIMEOFDAY
  gettimeofday(p, NULL);
#else
  time(&p->tv_sec);
  p->tv_usec = 0;
#endif
}

void reset_time()
{
  current_time(&tm0);
}

long elapsed_time()
{
  struct TMV tm;

  current_time(&tm);
  tm.tv_usec -= tm0.tv_usec;
  if (tm.tv_usec < 0) {
    tm.tv_usec += 1000000;
    tm.tv_sec--;
  }
  tm.tv_sec -= tm0.tv_sec;
  if (tm.tv_sec > 86400L)	/* 24 hour */
    tm.tv_sec = 86400L;
  return tm.tv_sec * 1000 + tm.tv_usec / 1000;
}

void sleep_time(n)
     int n;			/* milliseconds */
{
#ifdef USE_USLEEP
  long m;
  
  /* sleep milliseconds */
  m = n * 1000L;		/* to microseconds */
  if (m)
    usleep(m);
#else
  /* sleep seconds */
  n = (n+999)/1000;
  if (n)
    sleep(n);
#endif
}

/* End of file */
